<?php
// The source code packaged with this file is Free Software.
// Portions are Copyright (C) 2008 by the Social Web CMS Team <swcms@socialwebcms.com>.
// It's licensed under the AFFERO GENERAL PUBLIC LICENSE unless stated otherwise.
// You can get copies of the licenses here: http://www.affero.org/oagpl.html
// AFFERO GENERAL PUBLIC LICENSE is also included in the file called "COPYING".

// Portions are Copyright (C) Other Parties. Please see LICENSE.

/*

Social Web CMS Core Module
Name: FTP
Version: 0.10
Copyright: 2008 by the Social Web CMS Team swcms@socialwebcms.com.

*/

if(!defined('mnminclude')){header('Location: ../../404error.php');die();}

include_once(dirname(__FILE__) . '/ftp_class.php');

function ftp_get_login(){ 

	global $main_smarty, $the_template;

	force_authentication();
	$canIhaveAccess = 0;
	$canIhaveAccess = $canIhaveAccess + checklevel('god');

	if($canIhaveAccess == 1)
	{
	
		$_SESSION['swcms_current_ip'] = $_SERVER['REMOTE_ADDR'];
		
		$main_smarty->assign('message', $_SESSION['swcms_ftp_message']);
	
		$ftp_details = unserialize(get_misc_data('swcms_ftp_details'));
	
		if(isset($ftp_details['ftp_server'])){
			$main_smarty->assign('swcms_ftp_server', $ftp_details['ftp_server']);
		} else {
			$main_smarty->assign('swcms_ftp_server', '');
		}
		
		if(isset($ftp_details['ftp_login'])){
			$main_smarty->assign('swcms_ftp_login', $ftp_details['ftp_login']);
		} else {
			$main_smarty->assign('swcms_ftp_login', '');
		}
		
		if(isset($ftp_details['ftp_folder'])){
			$main_smarty->assign('swcms_ftp_folder', $ftp_details['ftp_folder']);
		} else {
			$main_smarty->assign('swcms_ftp_folder', '');
		}
			
		$main_smarty->assign('tpl_center', '../modules/swcms_core__ftp/templates/form');
		$main_smarty->display($the_template . '/pligg.tpl');
	
		die();
	}
}

function ftp_process_form(){

	force_authentication();
	$canIhaveAccess = 0;
	$canIhaveAccess = $canIhaveAccess + checklevel('god');

	if($canIhaveAccess == 1)
	{
	
		$ftp_details = array(
			'ftp_server' => sanitize($_POST['swcms_server'], 3),
			'ftp_login' => sanitize($_POST['swcms_login'], 3),
			'ftp_folder' => sanitize($_POST['swcms_folder'], 3)
		);

		// save the details (but NOT the password) for later use		
			misc_data_update('swcms_ftp_details', serialize($ftp_details));
	
		$ftp_details['ftp_password'] = sanitize($_POST['swcms_password'], 3);
		
		// save the details to session for later use
			$_SESSION['swcms_ftp_details'] = serialize($ftp_details);
		

		// if there is a log file, delete it
			$ftplog =  './cache/ftp.log';
			unlink($ftplog);

		// Verify the FTP details
			$ftp_details = unserialize($_SESSION['swcms_ftp_details']);		
				
			$ftp = new ftp(false);
			$ftp->Verbose = false;
			$ftp->LocalEcho = false;
			if(!$ftp->SetServer($ftp_details['ftp_server'])) {
				ftp_write_log($ftp->log);
				$ftp->quit();
				$_SESSION['swcms_ftp_message'] = 'Error: Cannot connect to the server.';
				ftp_get_login();
				die();
			}
	
			if (!$ftp->connect()) {
				ftp_write_log($ftp->log);
				$ftp->quit();
				$_SESSION['swcms_ftp_message'] = 'Error: Cannot connect to the server.';
				ftp_get_login();
				die();
			}
			if (!$ftp->login($ftp_details['ftp_login'], $ftp_details['ftp_password'])) {
				ftp_write_log($ftp->log);
				$ftp->quit();
				$_SESSION['swcms_ftp_message'] = 'Error: Login Failed.';
				ftp_get_login();
				die();
			}
	
			// Try to change directory to the location given	
				$folder = $ftp_details['ftp_folder'];
				$folder = str_replace('\\', '/', $folder);
				$folders = explode('/', $folder);
	
				foreach($folders as $f){
					if($f != '/' && $f != ''){
						$ftp->chdir($f);
					}
				}
	
	
			// create a temp file in the cache folder
			// then see (via FTP) if the file exists. if it does, then we're in the right place
				$somecontent = rand(1,999999999);
				$filename = 'ftptest_' . $somecontent;
				$filename =  './cache/' . $filename;
	
				// if the file already exists, kill it
					unlink($filename);
				
				if (!$handle = fopen($filename, 'w')) {
					die("Cannot open file ($filename)");
				}
			
				if (fwrite($handle, $somecontent) === FALSE) {
					die("Cannot write to file ($filename)");
				}
			
				fclose($handle);
	
			// cd to the cache folder
				$ftp->chdir('cache');
						
	
			// check to see if that temp file we created exists
				$exists = $ftp->is_exists('ftptest_' . $somecontent);
	
				unlink($filename);
	
			// write to the log file	
				ftp_write_log($ftp->log);
		
				$ftp->quit();		
	
			// if the temp file does NOT exist
				if(!$exists){
					$_SESSION['swcms_ftp_message'] = 'Error: Login successful but folder appears to be incorrect.';				
					ftp_get_login();
					die();
				
				}

	} // $canIhaveAccess
} // function

function ftp_write_log($text){

	// this is for debugging.
	// $log will eventually be set in the admin panel

	$log = false;

	if($log == true){

		$filename =  './cache/ftp.log';
		
		if (!$handle = fopen($filename, 'a')) {
			die("Cannot open file ($filename)");
		}
	
		if (fwrite($handle, $text) === FALSE) {
			die("Cannot write to file ($filename)");
		}
	
		fclose($handle);
	}

}

?>